# Method: services.report

- [HTTP request](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/services/report#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/services/report#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/services/report#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/services/report#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/services/report#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/services/report#body.ReportResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/services/report#body.aspect)

This method provides telemetry reporting for services that are integrated with [Service Infrastructure](https://cloud.google.com/service-infrastructure). It reports a list of operations that have occurred on a service. It must be called after the operations have been executed. For more information, see [Telemetry Reporting](https://cloud.google.com/service-infrastructure/docs/telemetry-reporting).

NOTE: The telemetry reporting has a hard limit of 1000 operations and 1MB per services.report call. It is recommended to have no more than 100 operations per call.

This method requires the `servicemanagement.services.report` permission on the specified service. For more information, see [Service Control API Access Control](https://cloud.google.com/service-infrastructure/docs/service-control/access-control).

### HTTP request

`POST https://servicecontrol.googleapis.com/v2/services/{serviceName}:report`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `serviceName` | `string` The service name as specified in its service configuration. For example, `"pubsub.googleapis.com"`. See [google.api.Service](https://cloud.google.com/service-management/reference/rpc/google.api#google.api.Service) for the definition of a service name. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "serviceConfigId": string, "operations": [ { object (`https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/AttributeContext`) } ] } ``` |

| Fields ||
|---|---|
| `serviceConfigId` | `string` Specifies the version of the service configuration that should be used to process the request. Must not be empty. Set this field to 'latest' to specify using the latest configuration. |
| `operations[]` | ``object (`https://docs.cloud.google.com/service-infrastructure/docs/service-control/reference/rest/v2/AttributeContext`)`` Describes the list of operations to be reported. Each operation is represented as an AttributeContext, and contains all attributes around an API access. |

### Response body

Response message for the services.report method.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "extensions": { "@type": string, field1: ..., ... } } ``` |

| Fields ||
|---|---|
| `extensions` | `object` The extension field to store serialized OTel responses. e.g. ExportLogsServiceResponse, ExportMetricsServiceResponse. An object containing fields of an arbitrary type. An additional field `"@type"` contains a URI identifying the type. Example: `{ "id": 1234, "@type": "types.example.com/standard/id" }`. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/servicecontrol`
- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).